package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.busi.jx;

import cn.estsh.i3plus.ext.mes.api.busi.jx.IJxCenterWorkingBoardService;
import cn.estsh.i3plus.ext.mes.pojo.bean.MesAssistOutAndEnter;
import cn.estsh.i3plus.ext.mes.pojo.bean.MesShiftProdCenterPm;
import cn.estsh.i3plus.ext.mes.pojo.repository.MesAssistOutAndEnterRepository;
import cn.estsh.i3plus.ext.mes.pojo.repository.MesShiftProdCenterPmRepository;
import cn.estsh.i3plus.ext.mes.pojo.util.MesExtConstWords;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.impp.framework.boot.util.SpringContextsUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.util.CollectionUtils;
import org.springframework.util.StringUtils;

import java.util.List;
import java.util.Map;

/**
 * @Author : wangjie
 * @CreateDate : 2022-02-15
 * @Modify:
 **/
@Slf4j
public class JxCenterWorkingBoardProxyAssistService implements IJxCenterWorkingBoardService {

    private MesAssistOutAndEnterRepository assistOutAndEnterRepository;

    public JxCenterWorkingBoardProxyAssistService() {
        this.assistOutAndEnterRepository = (MesAssistOutAndEnterRepository) SpringContextsUtil.getBean("mesAssistOutAndEnterRepository");
    }

    @Override
    public Map<String, Object> queryCenterWorkingBoardData(Map<String, Object> dataMap) {

        String organizeCode = (String) dataMap.get(MesExtConstWords.ORGANIZE_CODE);
        String workCenterCode = (String) dataMap.get(MesExtConstWords.WORK_CENTER_CODE);
        String startTime = (String) dataMap.get(MesExtConstWords.START_TIME);
        String endTime = (String) dataMap.get(MesExtConstWords.END_TIME);

        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.timeBuilder(startTime, endTime, MesExtConstWords.WORK_TIME, true, true, packBean);
        List<MesAssistOutAndEnter> assistOutAndEnterList = assistOutAndEnterRepository.findByHqlWhere(packBean);

        if (CollectionUtils.isEmpty(assistOutAndEnterList)) return dataMap;

        dataMap.put(MesAssistOutAndEnter.class.getSimpleName(), assistOutAndEnterList);

        return dataMap;
    }

}
